diff --git a/.gitlab-ci.yml b/.gitlab-ci.yml
index 20ce2c0cf99b20ac003d4eda2ce004b12eb9756a..06be81eb583f201e58977748ff2c6ac5235bb589 100644
--- a/.gitlab-ci.yml
+++ b/.gitlab-ci.yml
@@ -69,7 +69,7 @@ ubuntu_boost_system:
     tags:
         - centos7
 
-    image: martinbeseda/dockertest:latest
+    image: martinbeseda/ubuntu-ci:latest
 
     before_script:
         - rm -rf external_dependencies/boost/*
diff --git a/build_scripts/linux/linux_gcc_build_x64_debug_local.sh b/build_scripts/linux/linux_gcc_build_x64_debug_local.sh
index 0b7c6359b874a4fb856c8eb4ff2e70c5632ed110..8c5214525dedb422e3bfce056cd5b00c9a1581f8 100755
--- a/build_scripts/linux/linux_gcc_build_x64_debug_local.sh
+++ b/build_scripts/linux/linux_gcc_build_x64_debug_local.sh
@@ -26,13 +26,13 @@ if [ -z ${DEPENDENCIES_LINK_TYPE} ]; then DEPENDENCIES_LINK_TYPE=static; fi
 if [ -z ${CLEAN_AFTER} ]; then CLEAN_AFTER=yes; fi
 
 export LINK_TYPE=static
-if [ $DEPENDENCIES_LINK_TYPE = "shared" ]
+if [ ${DEPENDENCIES_LINK_TYPE} = "shared" ]
 then
     export LINK_TYPE=shared
 fi
 
 CLEAN_AF=yes
-if [ $CLEAN_AFTER = "no" ]
+if [ ${CLEAN_AFTER} = "no" ]
 then
     CLEAN_AF=no
 fi
@@ -52,7 +52,7 @@ echo "Building the '${CYAN}lib4neuro${NC}' project for ${WHITE}Debug${NC}"
 BUILD_SOMETHING=no
 BUILD_SOMETHING_LIB=no
 
-if [ $BUILD_LIB = "yes" ]
+if [ ${BUILD_LIB} = "yes" ]
 then
     echo "${CYAN}lib4neuro${NC} build type: ${WHITE}Debug${NC}"
     echo "${CYAN}lib4neuro${NC} build architecture: ${WHITE}x64${NC}"
@@ -68,14 +68,14 @@ then
     BUILD_SOMETHING_LIB=yes
 fi
 
-if [ $BUILD_EXAMPLES = "yes" ]
+if [ ${BUILD_EXAMPLES} = "yes" ]
 then
     echo "${CYAN}lib4neuro${NC} examples will be built in '${YELLOW}build/examples${NC}'"
     BUILD_SOMETHING=yes
     BUILD_SOMETHING_LIB=yes
 fi
 
-if [ $REBUILD_BOOST = "yes" ]
+if [ ${REBUILD_BOOST} = "yes" ]
 then
     echo "The required '${CYAN}BOOST${NC}' library will be recompiled in the directory '${YELLOW}external_dependencies/boost${NC}'"
     rm -rf ../../external_dependencies/boost/stage
@@ -85,26 +85,26 @@ fi
 
 
 # Boost rebuild
-if [ $REBUILD_BOOST = "yes" ]
+if [ ${REBUILD_BOOST} = "yes" ]
 then
     ./build_boost_gcc.sh || BUILD_ERROR_OCCURED=1
 fi
 
 # Should we build the lib4neuro library? (yes)
-if [ $BUILD_SOMETHING_LIB = "yes" -a $BUILD_ERROR_OCCURED = "0" ]
+if [ ${BUILD_SOMETHING_LIB} = "yes" -a $BUILD_ERROR_OCCURED = "0" ]
 then
 
-    if [ $BUILD_LIB = "yes" ]
+    if [ ${BUILD_LIB} = "yes" ]
     then
         ./linux_clean_lib.sh
     fi
 
-    if [ $BUILD_EXAMPLES = "yes" ]
+    if [ ${BUILD_EXAMPLES} = "yes" ]
     then
         ./linux_clean_examples.sh
     fi
 
-    if [ $BUILD_TESTS = "yes" ]
+    if [ ${BUILD_TESTS} = "yes" ]
     then
         ./linux_clean_tests.sh
     fi	
@@ -114,12 +114,12 @@ then
 
     cd ../..
 
-    cmake -DCMAKE_VERBOSE_MAKEFILE:BOOL=ON -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=${CXX_COMPILER} -DCMAKE_C_COMPILER=${C_COMPILER} -DBOOST_LIBRARYDIR=${BOOST_LIBRARYDIR} -DBOOST_INCLUDEDIR=${BOOST_INCLUDEDIR} -DBUILD_TESTS=${BUILD_TESTS} -DBUILD_EXAMPLES=${BUILD_EXAMPLES} -DBUILD_LIB=${BUILD_LIB} -DLIB4NEURO_DIR=${PWD}/build/lib -DDEPENDENCIES_LINK_TYPE=${LINK_TYPE} -DLIB4NEURO_INCLUDE_DIR=${LIB4NEURO_INCLUDE_DIR} . || ( echo "${RED}Makefile preparation finished with errors${NC}!"; BUILD_ERROR_OCCURED=1; )
+    cmake -DCMAKE_VERBOSE_MAKEFILE:BOOL=ON -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=${CXX_COMPILER} -DCMAKE_C_COMPILER=${C_COMPILER} -DBOOST_LIBRARYDIR=${BOOST_LIBRARYDIR} -DBOOST_INCLUDEDIR=${BOOST_INCLUDEDIR} -DBUILD_TESTS=${BUILD_TESTS} -DBUILD_EXAMPLES=${BUILD_EXAMPLES} -DBUILD_LIB=${BUILD_LIB} -DLIB4NEURO_DIR=${PWD}/build/lib -DDEPENDENCIES_LINK_TYPE=${LINK_TYPE} -DLIB4NEURO_INCLUDE_DIR=${LIB4NEURO_INCLUDE_DIR} . || echo "${RED}Makefile preparation finished with errors${NC}!"; BUILD_ERROR_OCCURED=1;
 
-	if [ $BUILD_ERROR_OCCURED = "0" ]
+	if [ ${BUILD_ERROR_OCCURED} = "0" ]
 	then
         echo "Building the '${CYAN}lib4neuro${NC}' project for ${WHITE}Debug${NC} (building)"
-        ( cmake --build . --config Debug -- -j${N_CORES}  ) && ( echo "${GREEN}Build complete${NC}." ) || ( echo "${RED}Build finished with errors${NC}!"; BUILD_ERROR_OCCURED=1; )
+        cmake --build . --config Debug -- -j${N_CORES} && echo "${GREEN}Build complete${NC}." || echo "${RED}Build finished with errors${NC}!"; BUILD_ERROR_OCCURED=1;
 	fi
 
     cd build_scripts/linux
@@ -128,28 +128,28 @@ fi
 
 if [ ${CLEAN_AF} = "yes" ]
 then
-if [ $BUILD_LIB = "yes" ]
+if [ ${BUILD_LIB} = "yes" ]
 then
     ./linux_clean_after_lib.sh
 fi
 
-if [ $BUILD_EXAMPLES = "yes" ]
+if [ ${BUILD_EXAMPLES} = "yes" ]
 then
     ./linux_clean_after_examples.sh
 fi
 
-if [ $BUILD_TESTS = "yes" ]
+if [ ${BUILD_TESTS} = "yes" ]
 then
     ./linux_clean_after_tests.sh
 fi
 
-if [ $BUILD_SOMETHING_LIB = "yes" ]
+if [ ${BUILD_SOMETHING_LIB} = "yes" ]
 then
     ./linux_clean_garbage.sh
 fi
 fi
 
-if [ $BUILD_ERROR_OCCURED = "1" ]
+if [ ${BUILD_ERROR_OCCURED} = "1" ]
 then
     echo "${RED}Build encountered some errors!${NC}"
     exit 1
diff --git a/build_scripts/linux/linux_gcc_build_x64_debug_system.sh b/build_scripts/linux/linux_gcc_build_x64_debug_system.sh
index b729c581ef6fece246992e55fb351810c011d9a6..312b7a5f3ac26a9f6bbe4a8a4446b00c09c1cbb6 100755
--- a/build_scripts/linux/linux_gcc_build_x64_debug_system.sh
+++ b/build_scripts/linux/linux_gcc_build_x64_debug_system.sh
@@ -24,13 +24,13 @@ if [ -z ${DEPENDENCIES_LINK_TYPE} ]; then DEPENDENCIES_LINK_TYPE=static; fi
 if [ -z ${CLEAN_AFTER} ]; then CLEAN_AFTER=yes; fi
 
 LINK_TYPE=static
-if [ $DEPENDENCIES_LINK_TYPE = "shared" ]
+if [ ${DEPENDENCIES_LINK_TYPE} = "shared" ]
 then
     LINK_TYPE=shared
 fi
 
 CLEAN_AF=yes
-if [ $CLEAN_AFTER = "no" ]
+if [ ${CLEAN_AFTER} = "no" ]
 then
     CLEAN_AF=no
 fi
@@ -49,7 +49,7 @@ echo "Building the '${CYAN}lib4neuro${NC}' project for ${WHITE}Debug${NC}"
 BUILD_SOMETHING=no
 BUILD_SOMETHING_LIB=no
 
-if [ $BUILD_LIB = "yes" ]
+if [ ${BUILD_LIB} = "yes" ]
 then
     echo "${CYAN}lib4neuro${NC} build type: ${WHITE}Debug${NC}"
     echo "${CYAN}lib4neuro${NC} build architecture: ${WHITE}x64${NC}"
@@ -58,14 +58,14 @@ then
     BUILD_SOMETHING_LIB=yes
 fi
 
-if [ $BUILD_TESTS = "yes" ]
+if [ ${BUILD_TESTS} = "yes" ]
 then
     echo "${CYAN}lib4neuro${NC} unit tests will be built in '${YELLOW}build/unit-tests${NC}'"
     BUILD_SOMETHING=yes
     BUILD_SOMETHING_LIB=yes
 fi
 
-if [ $BUILD_EXAMPLES = "yes" ]
+if [ ${BUILD_EXAMPLES} = "yes" ]
 then
     echo "${CYAN}lib4neuro${NC} examples will be built in '${YELLOW}build/examples${NC}'"
     BUILD_SOMETHING=yes
@@ -76,20 +76,20 @@ rm -rf ../../external_dependencies/boost/*
 rm -rf ../../external_dependencies/exprtk/*
 
 # Should we build the lib4neuro library? (yes)
-if [ $BUILD_SOMETHING_LIB = "yes" -a $BUILD_ERROR_OCCURED = "0" ]
+if [ ${BUILD_SOMETHING_LIB} = "yes" -a ${BUILD_ERROR_OCCURED} = "0" ]
 then
 
-    if [ $BUILD_LIB = "yes" ]
+    if [ ${BUILD_LIB} = "yes" ]
     then
         ./linux_clean_lib.sh
     fi
 
-    if [ $BUILD_EXAMPLES = "yes" ]
+    if [ ${BUILD_EXAMPLES} = "yes" ]
     then
         ./linux_clean_examples.sh
     fi
 
-    if [ $BUILD_TESTS = "yes" ]
+    if [ ${BUILD_TESTS} = "yes" ]
     then
         ./linux_clean_tests.sh
     fi	
@@ -99,12 +99,12 @@ then
 
     cd ../..
 
-    cmake -DCMAKE_VERBOSE_MAKEFILE:BOOL=ON -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=${CXX_COMPILER} -DCMAKE_C_COMPILER=${C_COMPILER} -DBOOST_LIBRARYDIR=${BOOST_LIBRARYDIR} -DBOOST_INCLUDEDIR=${BOOST_INCLUDEDIR} -DBUILD_TESTS=${BUILD_TESTS} -DBUILD_EXAMPLES=${BUILD_EXAMPLES} -DBUILD_LIB=${BUILD_LIB} -DLIB4NEURO_DIR=${PWD}/build/lib -DDEPENDENCIES_LINK_TYPE=${LINK_TYPE} -DLIB4NEURO_INCLUDE_DIR=${LIB4NEURO_INCLUDE_DIR} . || ( echo "${RED}Makefile preparation finished with errors${NC}!"; BUILD_ERROR_OCCURED=1; )
+    cmake -DCMAKE_VERBOSE_MAKEFILE:BOOL=ON -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=${CXX_COMPILER} -DCMAKE_C_COMPILER=${C_COMPILER} -DBOOST_LIBRARYDIR=${BOOST_LIBRARYDIR} -DBOOST_INCLUDEDIR=${BOOST_INCLUDEDIR} -DBUILD_TESTS=${BUILD_TESTS} -DBUILD_EXAMPLES=${BUILD_EXAMPLES} -DBUILD_LIB=${BUILD_LIB} -DLIB4NEURO_DIR=${PWD}/build/lib -DDEPENDENCIES_LINK_TYPE=${LINK_TYPE} -DLIB4NEURO_INCLUDE_DIR=${LIB4NEURO_INCLUDE_DIR} . || echo "${RED}Makefile preparation finished with errors${NC}!"; BUILD_ERROR_OCCURED=1;
 
-	if [ $BUILD_ERROR_OCCURED = "0" ]
+	if [ ${BUILD_ERROR_OCCURED} = "0" ]
 	then
         echo "Building the '${CYAN}lib4neuro${NC}' project for ${WHITE}Debug${NC} (building)"
-        ( cmake --build . --config Debug -- -j${N_CORES}  ) && ( echo "${GREEN}Build complete${NC}." ) || ( echo "${RED}Build finished with errors${NC}!"; BUILD_ERROR_OCCURED=1; )
+        cmake --build . --config Debug -- -j${N_CORES} && echo "${GREEN}Build complete${NC}." || echo "${RED}Build finished with errors${NC}!"; BUILD_ERROR_OCCURED=1;
 	fi
 
     cd build_scripts/linux
@@ -113,29 +113,30 @@ fi
 
 if [ ${CLEAN_AF} = "yes" ]
 then
-if [ $BUILD_LIB = "yes" ]
+
+if [ ${BUILD_LIB} = "yes" ]
 then
     ./linux_clean_after_lib.sh
 fi
 
-if [ $BUILD_EXAMPLES = "yes" ]
+if [ ${BUILD_EXAMPLES} = "yes" ]
 then
     ./linux_clean_after_examples.sh
 fi
 
-if [ $BUILD_TESTS = "yes" ]
+if [ ${BUILD_TESTS} = "yes" ]
 then
     ./linux_clean_after_tests.sh
 fi
 
-if [ $BUILD_SOMETHING_LIB = "yes" ]
+if [ ${BUILD_SOMETHING_LIB} = "yes" ]
 then
     ./linux_clean_garbage.sh
 fi
-fi
 
+fi
 
-if [ $BUILD_ERROR_OCCURED = "1" ]
+if [ ${BUILD_ERROR_OCCURED} = "1" ]
 then
     echo "${RED}Build encountered some errors!${NC}"
     exit 1
diff --git a/build_scripts/windows/win_VS_build_x64_debug.bat b/build_scripts/windows/win_VS_build_x64_debug.bat
index 2071067f51d60ed2be901ec064bb3674f1106277..86c3b1e39cc20dc9f32814331dbfcb81b56b7cce 100644
--- a/build_scripts/windows/win_VS_build_x64_debug.bat
+++ b/build_scripts/windows/win_VS_build_x64_debug.bat
@@ -106,6 +106,7 @@ IF "%BUILD_SOMETHING_LIB%"=="yes" (
 	
 	cd ..\..
 	cmake -G "Visual Studio 15 2017 Win64" -DCMAKE_VERBOSE_MAKEFILE:BOOL=ON -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=%CXX_COMPILER% -DCMAKE_C_COMPILER=%C_COMPILER% -DBOOST_ROOT=%BOOST_ROOT% -DBOOST_LIBRARYDIR=%BOOST_LIBRARYDIR% -DBOOST_INCLUDEDIR=%BOOST_INCLUDEDIR% -DBUILD_TESTS=%BUILD_TESTS% -DBUILD_EXAMPLES=%BUILD_EXAMPLES% -DBUILD_LIB=%BUILD_LIB% -DLIB4NEURO_DIR=build\lib -DDEPENDENCIES_LINK_TYPE=%LINK_TYPE% -DLIB4NEURO_INCLUDE_DIR=%LIB4NEURO_INCLUDE_DIR% . || goto error_occured_lib
+rem	cmake -G "mingw32-make" -DCMAKE_VERBOSE_MAKEFILE:BOOL=ON -DCMAKE_BUILD_TYPE=Debug -DCMAKE_CXX_COMPILER=%CXX_COMPILER% -DCMAKE_C_COMPILER=%C_COMPILER% -DBOOST_ROOT=%BOOST_ROOT% -DBOOST_LIBRARYDIR=%BOOST_LIBRARYDIR% -DBOOST_INCLUDEDIR=%BOOST_INCLUDEDIR% -DBUILD_TESTS=%BUILD_TESTS% -DBUILD_EXAMPLES=%BUILD_EXAMPLES% -DBUILD_LIB=%BUILD_LIB% -DLIB4NEURO_DIR=build\lib -DDEPENDENCIES_LINK_TYPE=%LINK_TYPE% -DLIB4NEURO_INCLUDE_DIR=%LIB4NEURO_INCLUDE_DIR% . || goto error_occured_lib
 	title Building the 'lib4neuro' project for Debug [building]
 	cmake --build . --config Debug && echo "Build complete." || goto error_occured_lib